car([], null).
car([X|_], X).

cdr([], null).
cdr([_|Xs], Xs).

cons(X, [], [X]).
cons(X, [Y|Ys], [X,Y|Ys]).

clan(X, [X|_]).
clan(X, [_|Ys]) :- clan(X, Ys).

spoji([], [], []).
spoji(L, [], L).
spoji([], L, L).
spoji([X|Xs], Ys, [X|Zs]) :- spoji(Xs, Ys, Zs).

duzina([], 0).
duzina([_|Xs], N) :- duzina(Xs, M), N is M+1.

poslednji([], null) :- !.
poslednji([X], X) :- !.
poslednji([_|Xs], P) :- poslednji(Xs, P).

prefikspom([], [X|_], X) :- !.
prefikspom([Y|Zs], [Y|Ys], X) :- prefikspom(Zs, Ys, X).

prefiks(Pre, Xs, X) :- clan(X, Xs), prefikspom(Pre, Xs, X), !.
prefiks(Xs, Xs, _). 

sufiks([], [X], X) :- !.
sufiks(Xs, [X|Xs], X) :- !.
sufiks(Zs, [_|Ys], X) :- sufiks(Zs, Ys, X).

okret([], []).
okret([X|Xs], Ys) :- okret(Xs, Pom), spoji(Pom, [X], Ys).

prefiks1([], _).
prefiks1([P|Pres], [P|Xs]) :- prefiks1(Pres, Xs).

insertsort(X, [], [X]) :- !.
insertsort(X, [Y|Ys], [X,Y|Ys]) :- X<Y, !.
insertsort(X, [Y|Ys], [Y|Zs]) :- insertsort(X, Ys, Zs).

sortiraj([], []).
sortiraj([L|Ls], SL) :- sortiraj(Ls, Pom)
				, insertsort(L, Pom, SL).



